#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T2> inline int chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline int chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (1 << 17);
const int bound = (int)1e6 + 42;

struct edge
{
	int x, y1, y2, val;
	edge() {x = -1; y1 = -1; y2 = -1; val = -1;}
	edge(int _x, int _y1, int _y2, int _val)
	{
		x = _x;
		y1 = _y1;
		y2 = _y2;
		val = _val;
	}
};

bool operator<(const edge &e1, const edge &e2)
{
	return e1.x < e2.x;
}

int n;
vector<edge> e;

void add_rect(int mnx, int mny, int mxx, int mxy)
{
    if(mxx < mnx) return;
	if(mxy < mny) return;

	e.push_back(edge(mnx, mny, mxy, 1));
	e.push_back(edge(mxx + 1, mny, mxy, -1));
}

const int inf = (int)1e9 + 42;
const int O = (int)1e7;

void read()
{
	cin >> n;
	for(int i = 0; i < n; i++)
	{
        int p, w, e;
        cin >> p >> w >> e;

        int l = p - w, r = p + e;

        add_rect(l, -O, l, +O);
        add_rect(r, -O, r, -O);

        add_rect(-O, l, l - 1, l);
        add_rect(-O, r, l - 1, r);

        add_rect(r + 1, l, +O, l);
        add_rect(r + 1, r, +O, r);

        add_rect(l + 1, l, r - 1, l);
        add_rect(l + 1, r, r - 1, r);
	}
}

struct node
{
    long long cnt, mx, lazy;
    node() { mx = 0; cnt = 1; lazy = 0; }
};

node merge(node l, node r)
{
    node ret;
    ret.cnt = 0;
    ret.mx = max(l.mx, r.mx);
    if(ret.mx == l.mx) ret.cnt += l.cnt;
    if(ret.mx == r.mx) ret.cnt += r.cnt;
    ret.lazy = 0;
    return ret;
}

node mult(node t, long long x)
{
    t.cnt *= x;
    return t;
}

struct segment_tree
{
    node tr[4 * 2 * bound];

    void push(int l, int r, int idx)
    {
        if(tr[idx].lazy)
        {
            tr[idx].mx += tr[idx].lazy;
            if(l != r)
            {
                tr[2 * idx + 1].lazy += tr[idx].lazy;
                tr[2 * idx + 2].lazy += tr[idx].lazy;
            }

            tr[idx].lazy = 0;
        }
    }

    void init(int l, int r, int idx)
    {
        if(l == r)
            return;

        int mid = (l + r) >> 1;
        init(l, mid, 2 * idx + 1);
        init(mid + 1, r, 2 * idx + 2);

        tr[idx] = merge(tr[2 * idx + 1], tr[2 * idx + 2]);
    }

    void add(int ql, int qr, int x, int l, int r, int idx)
    {
        push(l, r, idx);
        if(ql > r || l > qr) return;

        if(ql <= l && r <= qr)
        {
            tr[idx].lazy += x;
            push(l, r, idx);
            return;
        }

        int mid = (l + r) >> 1;
        add(ql, qr, x, l, mid, 2 * idx + 1);
        add(ql, qr, x, mid + 1, r, 2 * idx + 2);

        tr[idx] = merge(tr[2 * idx + 1], tr[2 * idx + 2]);
    }
};

segment_tree t;

inline int mabs(int x) { return x < 0 ? -x : x; }

node solve_node()
{
	sort(e.begin(), e.end());
    t.init(-bound, +bound, 0);

	int last = -inf;
	node ans;
    ans.cnt = 0;

	for(int i = 0; i < e.size();)
	{
        int j = i;
		t.push(-bound, +bound, 0);
		ans = merge(ans, mult(t.tr[0], mabs(e[j].x - last)));
        while(i < (int)e.size() && e[j].x == e[i].x)
        {
            t.add(e[i].y1, e[i].y2, e[i].val, -bound, +bound, 0);
            i++;
        }

		last = e[j].x;
	}

	return ans;
}

void solve()
{
    node it = solve_node();
	cout << it.mx << " " << it.cnt << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}

