#include <iostream>
#include <set>
#include <queue>
#include "stations.h"
#include <map>
using namespace std;
long long n, l, cap, p[(1<<20)],val[(1<<20)];
set < long long > act;
long long cUsed[(1<<20)];
priority_queue < pair < long long, long long > > q;
map < long long,long long > onInd;
long long ans;

long long init( int L, int K, int N, int stationPositions[], int stationOilPrices[] ) {

    n = N;
    cap = K;
    l = L;

    for ( int i = 0 ; i < n ; i ++ ) {
        p[i] =stationPositions[i];
        val[i] = stationOilPrices[i];
    }

    act.clear();
    onInd.clear();
    ans = 0;

    for ( int i = 0 ; i < n ; i ++ ) {
        if ( p[i] == l ) { continue; }
        q.push( make_pair( -val[i], i ) );
        onInd[p[i]]= i;
    }
    act.insert ( -cap );
    act.insert ( l );

    for ( ; !q.empty() ; ) {
        int v = -q.top().first, x = q.top().second;
        q.pop();

        auto pr = act.upper_bound( p[x] );
        auto nxt = pr;
        pr --;

        int i1, i2;
        i1 = *pr;
        i2 = *nxt;

//        cout << "checking" << p[x] << ": "<<i1 << " "<< i2 << "\n";

        if ( i2-i1 > cap ) {
            act.insert( p[x] );
            long long d1 = p[x] - i1;
            long long d2 = i2-p[x];

            if ( d1 > cap ) {
                cUsed[x] = min( d2, cap );
            }else {
                long long crr = cap-d1;
                cUsed[x] = min( d2, d1 );
            }

            ans += 1LL*cUsed[x]*val[x];
        }
    }

    for ( auto it = act.begin(); it!=act.end() ;it ++ ) {
        if( (*it) >=0 &&(*it)< l) {
   //         cout << (*it) << "," << cUsed[onInd[(*it)]] << " ";
        }
    }
    return ans;
}

long long addStation( int newStationPosition, int newStationOilPrice ) {
    p[n] = newStationPosition;
    val[n] = newStationOilPrice;
    n ++;

    act.clear();
    onInd.clear();
    ans = 0;

    for ( int i = 0 ; i < n ; i ++ ) {
        if ( p[i] == l ) { continue; }

        q.push( make_pair( -val[i], i ) );
        onInd[p[i]]= i;
        cUsed[i]=0;
    }
    act.insert ( -cap );
    act.insert ( l );

    for ( ; !q.empty() ; ) {
        int v = -q.top().first, x = q.top().second;
        q.pop();

        auto pr = act.upper_bound( p[x] );
        auto nxt = pr;
        pr --;

        int i1, i2;
        i1 = *pr;
        i2 = *nxt;

//        cout << "checking" << p[x] << ": "<<i1 << " "<< i2 << "\n";

        if ( i2-i1 > cap ) {
            act.insert( p[x] );
            long long d1 = p[x] - i1;
            long long d2 = i2-p[x];

            if ( d1 > cap ) {
                cUsed[x] = min( d2, cap );
            }else {
                int crr = cap-d1;
                cUsed[x] = min( d2, d1 );
            }

            ans += 1LL*cUsed[x]*val[x];
        }
    }

    for ( auto it = act.begin(); it!=act.end() ;it ++ ) {
        if( (*it) >=0 &&(*it)< l) {
    //        cout << (*it) << "," << cUsed[onInd[(*it)]] << " ";
        }
    }

    return -42;

    return ans;

}

/*
5 42 100
0 210
35 215
40 212
68 220
82 216

6 42 100
0 210
35 215
40 212
68 220
82 216
90 209


*/
