#include "stations.h"

#include<iostream>
#include<algorithm>

using namespace std;
const int MAX_N=5000;
struct Station
{
    long long p;
    long long o;
};
bool cmp(const Station& a, const Station& b)
{
    return a.p<b.p;
}
Station s[MAX_N];
long long l,n,k;
long long dp[MAX_N][MAX_N];
long long dist[MAX_N][MAX_N];
long long ans;
long long inf=1e18;
void reset()
{
    /*cerr<<endl;
    for (int i=0; i<n; ++i)
    {
        cerr<<s[i].p<<' '<<s[i].o<<endl;
    }
    cerr<<endl;*/
    sort(s,s+n,cmp);
    for (int i=0; i<n; ++i)
    {
        for (int j=i; j<n; ++j)
        {
            dp[i][j]=inf;
            dist[i][j]=s[j].p-s[i].p;
        }
        for (int j=0; j<n; ++j)
        {
            dp[i][n+j]=inf;
            dist[i][n+j]=k+s[j].p-s[i].p;
        }
        dist[i][0]=l-s[i].p;
    }
    ans=0;
    /*for (int i=0; i<n; ++i)
    {
        cerr<<s[i].p<<' '<<s[i].o<<endl;
    }
    cerr<<endl;*/
}
void process(int a)
{
    long long c1,c2;
    if (a==0)
    {
        for (int i=a+1; i<n; ++i)
        {
            if (dist[a][i]<=k) dp[a][i]=dist[a][i]*s[a].o;
            else dp[a][i]=inf;
            //cerr<<a<<' '<<i<<": "<<dp[a][i]<<endl;
        }
        for (int i=0; i<n; ++i)
        {
            if (dist[a][n+i]<=k) dp[a][n+i]=dist[a][n+i]*s[a].o;
            else dp[a][n+i]=inf;
            //cerr<<a<<" m "<<i<<": "<<dp[a][n+i]<<endl;
        }
        if (dist[a][0]<=k) dp[a][0]=dist[a][0]*s[a].o;
        else dp[a][0]=inf;
        //cerr<<a<<" finish"<<": "<<dp[a][0]<<endl;
    }
    else
    {
        for (int i=a+1; i<n; ++i)
        {
            if (dist[a][i]<=k)
            {
                c1=dp[a-1][a]+dist[a][i]*s[a].o;
                if (dist[a-1][i]<=k) c2=dp[a-1][i];
                else c2=dp[a-1][n+a-1]+(dist[a-1][i]-k)*s[a].o;
                dp[a][i]=min(c1,c2);
            }
            else dp[a][i]=inf;
            //cerr<<a<<' '<<i<<": "<<dp[a][i]<<endl;
        }
        for (int i=0; i<n; ++i)
        {
            if (s[i].p+k<s[a].p) continue;
            if (dist[a][n+i]<=k)
            {
                c1=dp[a-1][a]+dist[a][n+i]*s[a].o;
                if (dist[a-1][n+i]<=k) c2=dp[a-1][n+i];
                else c2=dp[a-1][n+a-1]+(dist[a-1][n+i]-k)*s[a].o;
                dp[a][n+i]=min(c1,c2);
            }
            else dp[a][n+i]=inf;
            //cerr<<a<<" m "<<i<<": "<<dp[a][n+i]<<endl;
        }
        if (dist[a][0]<=k)
        {
            if (s[a-1].o>s[a].o) dp[a][0]=dp[a-1][a]+dist[a][0]*s[a].o;
            else
            {
                if (dist[a-1][0]<=k) dp[a][0]=dp[a-1][0];
                else dp[a][0]=dp[a-1][n]+(dist[a-1][0]-k)*s[a].o;
            }
        }
        else dp[a][0]=inf;

        //cerr<<a<<" finish"<<": "<<dp[a][0]<<endl;
    }
    //cerr<<endl;
}
long long calc()
{
    for (int i=0; i<n; ++i)
    {
        process(i);
    }
    ans=dp[n-1][0];
    return ans;
}

long long init(int L, int K, int N, int stationPositions[], int stationOilPrices[])
{
    l=L;
    k=K;
    n=N;
    for (int i=0; i<n; ++i)
    {
        s[i].p=stationPositions[i];
        s[i].o=stationOilPrices[i];
    }
    reset();
    return calc();
}
long long addStation(int newStationPosition, int newStationOilPrice)
{
    s[n].p=newStationPosition;
    s[n].o=newStationOilPrice;
    ++n;
    reset();
    return calc();
}
