#include <iostream>
#include <cstdint>
#include <vector>

const uint32_t MAX_N = 101;

bool cur[MAX_N][MAX_N];
bool targ[MAX_N][MAX_N];
uint32_t n;
uint32_t x, y;
uint32_t tI;

std::vector<char> ans;

void input() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);
	std::cin >> n;
	for (uint32_t y = 0;y < n;y++) {
		for (uint32_t x = 0;x < n;x++) {
			char c;
			std::cin >> c;
			cur[x][y] = false;
			targ[x][y] = c == 'B';
		}
	}
	cur[0][0] = true;
	x = y = 0;
	std::cin >> tI;
}

bool vis[MAX_N][MAX_N];
void reset_vis() {
	for (uint32_t y = 0;y < n;y++) {
		for (uint32_t x = 0;x < n;x++) {
			vis[x][y] = false;
		}
	}
}
uint32_t dx[] = {0, 0, 1, (uint32_t)(-1)};
uint32_t dy[] = {1, (uint32_t) (-1), 0, 0};
bool inside(uint32_t x, uint32_t y) {
	return ((x < n) && (y < n));
}
void dfs(uint32_t x, uint32_t y) {
	if (vis[x][y]) {
		return;
	}
	vis[x][y] = 1;
	for (uint32_t d = 0;d < 4;d++) {
		uint32_t nX = x + dx[d];
		uint32_t nY = y + dy[d];
		if (!inside(nX, nY)) {
			continue;
		}
		if (targ[nX][nY] == targ[x][y]) {
			dfs(nX, nY);
		}
	}
}

void flip_col() {
	for (uint32_t i = 0;i < n;i++) {
		for (uint32_t j = 0;j < n;j++) {
			targ[i][j] = !targ[i][j];
			cur[i][j] = !cur[i][j];
		}
	}
}

bool conn_black() {
	uint32_t comp = 0;
	reset_vis();
	for (uint32_t i = 0;i < n;i++) {
		for (int32_t j = 0;j < n;j++) {
			if(!vis[i][j] && targ[i][j]) {
				comp++;
				dfs(i, j);
			}
		}
	}
	return comp == 1;
}

bool conn() {
	if (conn_black()) {
		return true;
	}
	flip_col();
	return conn_black();
}

char dir_name[] = {'D', 'U', 'R', 'L'};

void move_c(int32_t d, bool col = false) {
	uint32_t nX = x + dx[d];
	uint32_t nY = y + dy[d];
	char c = dir_name[d];
	if (!col) {
		c += 'a' - 'A';
	} else {
		cur[nX][nY] = cur[x][y];
	}
	x = nX;
	y = nY;
	ans.push_back(c);
}

void col_comp(uint32_t x, uint32_t y) {
	vis[x][y] = true;
	for (uint32_t i = 0;i < 4;i++) {
		uint32_t nX = x + dx[i];
		uint32_t nY = y + dy[i];
		if ((!inside(nX, nY)) || (vis[nX][nY]) || (targ[nX][nY] != targ[x][y])) {
			continue;

		}
		move_c(i, true);
		col_comp(nX, nY);
		move_c(i ^ 1, true);
	}
}

void solve_conn() {
	uint32_t tX, tY;
	bool found = false;
	for (uint32_t i = 1;i < n;i++) {
		for (uint32_t j = 0;j + 1 < n;j++) {
			if (targ[i][j]) {
				tX = i;
				tY = j;
				found = true;
				break;
			}
		}
		if (found) {
			break;
		}
	}
	if (cur[0][0]) {
		while (y < tY) {
			move_c(0, true);
		}
		while(x < tX) {
			move_c(2, true);
		}

		move_c(0, false);
		move_c(3, false);
		move_c(1, true);
		while (x > 0) {
			move_c(3, true);
		}
		while (y > 0) {
			move_c(1, true);
		}

		while(x < tX) {
			move_c(2, false);
		}
		while (y < tY) {
			move_c(0, false);
		}
	} else {
		for (uint32_t i = 0;i < n;i++) {
			if (i > 0) {
				move_c(0, true);
			}
			if (i == tY) {
				continue;
			}
			for (uint32_t j = 1;j < n;j++) {
				move_c(2, true);
			}
			for (uint32_t j = 1;j < n;j++) {
				move_c(3, false);
			}
		}
		for (uint32_t i = n - 1;i > 1 + tY;i--) {
			move_c(1, false);
		}
		for (uint32_t i = 1;i < n;i++) {
			move_c(2, false);
			if (i != tX) {
				move_c(1, true);
				move_c(0, false);
			}
		}
		for (uint32_t i = 1;i < n;i++) {
			move_c(3, false);
		}

	}
		while(x < tX) {
			move_c(2, false);
		}
		while (y > tY) {
			move_c(1, false);
		}
	reset_vis();
	col_comp(x, y);
}

void print_ans() {
	for (char c : ans) {
		std::cout << c;
	}
	std::cout << "\n";
	std::cerr << ans.size() << "\n";
}

int main() {
	input();
	if (conn()) {
		std::cerr << "connected, yay" << std::endl;
		solve_conn();
	} else {
		std::cerr << "shit";
		return 0;
	}
	print_ans();
}
