#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 100007;
const int ALL = 4*N;
const int TREE_SIZE = 4*ALL;
const int INF = (1e9) + 7;

int n,all,sz,p[ALL];
map < int, int > code;
vector < int > points_to[N];
vector < int > who[ALL];
int cnt[N];
pair < int, int > tree[TREE_SIZE] = { make_pair(0,0) };
pair < int, int > ans;

pair < int, int > merge_them(pair < int, int > a, pair < int, int > b) {
  if(a.first==b.first) return make_pair(a.first,a.second+b.second);
  return max(a,b);
}

void build_tree(int a, int b, int node) {
  if(a>b) return;
  if(a==b) {
    tree[node]=make_pair(cnt[a],1);
    return;
  }
  build_tree(a,(a+b)>>1,node<<1);
  build_tree(((a+b)>>1)+1,b,(node<<1)|1);
  tree[node]=merge_them(tree[node<<1],tree[(node<<1)|1]);
}

void update_tree(int a, int b, int pos, int node, int value) {
  if(a>b || a>pos || b<pos) return;
  if(a==b) {
    tree[node].first+=value;
    return;
  }
  update_tree(a,(a+b)>>1,pos,node<<1,value);
  update_tree(((a+b)>>1)+1,b,pos,(node<<1)|1,value);
  tree[node]=merge_them(tree[node<<1],tree[(node<<1)|1]);
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i,j,x,y,z;

  scanf("%d", &n);
  for(i=1;i<=n;i++) {
    scanf("%d %d %d", &x, &y, &z);
    
    set < int > curr;
    curr.insert(x-y);
    curr.insert(x+z);

    for(set < int >::iterator it=curr.begin();it!=curr.end();it++) {
      points_to[i].push_back(*it);
      p[++sz]=*it;
    }
  }

  sort(p+1,p+1+sz);
  code[p[1]]=1;
  for(i=2;i<=sz;i++) if(p[i]!=p[i-1]) {
    code[p[i]]=code[p[i-1]]+1;
  }
  all=code[p[sz]];

  for(i=1;i<=n;i++) {
    for(j=0;j<(int)(points_to[i].size());j++) {
      points_to[i][j]=code[points_to[i][j]];
      ++cnt[points_to[i][j]];
      who[points_to[i][j]].push_back(i);
    }
  }

  ans=make_pair(-1,0);

  build_tree(1,all,1);
  for(i=1;i<=all;i++) {
    int add=cnt[i];

    for(j=0;j<(int)(who[i].size());j++) {
      for(z=0;z<(int)(points_to[who[i][j]].size());z++) {
        update_tree(1,all,points_to[who[i][j]][z],1,-1);
      }
    }

    update_tree(1,all,i,1,-INF);
    
    pair < int, int > curr=tree[1];
    curr.first+=add;
    ans=merge_them(ans,curr);
  
    for(j=0;j<(int)(who[i].size());j++) {
      for(z=0;z<(int)(points_to[who[i][j]].size());z++) {
        update_tree(1,all,points_to[who[i][j]][z],1,1);
      }
    }

    update_tree(1,all,i,1,INF);
  }

  printf("%d %d\n", ans.first, ans.second/2);

  return 0;
}
