#include "stations.h"

#ifdef skeleta
  #include "Lgrader.cpp"
#endif

#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int TREE_SIZE = 10000007;
const int N = 100007;
const int INF = (1e9) + 7;

int n,k,l,pos[N],price[N];

struct tree_node {
  int from,to;

  long long sum;
  int max;
  int lazy;
  
  int left,right;
};

int nodes_count;
tree_node tree[TREE_SIZE];

int new_node(int l, int r) {
  ++nodes_count;
  tree[nodes_count].from=l;
  tree[nodes_count].to=r;
  tree[nodes_count].sum=0;
  tree[nodes_count].max=INF;
  tree[nodes_count].lazy=-1;
  tree[nodes_count].left=-1;
  tree[nodes_count].right=-1;

  return nodes_count;
}

long long get_sum(int node) {
  if(node==-1) return 0;
  return tree[node].sum;
}

int get_max(int node) {
  if(node==-1) return -INF;
  return tree[node].max;
}

pair < long long, int > merge_pairs(pair < long long, int > a, pair < long long, int > b) {
  return make_pair(a.first+b.first,max(a.second,b.second));
}

void extend_left(int node) {
  if(tree[node].left==-1 && tree[node].from<tree[node].to) {
    tree[node].left=new_node(tree[node].from,(tree[node].from+tree[node].to)/2);
  }
}

void extend_right(int node) {
  if(tree[node].right==-1 && tree[node].from<tree[node].to) {
    tree[node].right=new_node((tree[node].from+tree[node].to)/2+1,tree[node].to);
  }
}

void push_lazy(int node) {
  if(tree[node].lazy==-1) return;
  
  tree[node].max=tree[node].lazy;
  tree[node].sum=(tree[node].to-tree[node].from+1)*1ll*tree[node].lazy;

  if(tree[node].from<tree[node].to) {
    extend_left(node);
    extend_right(node);

    tree[tree[node].left].lazy=tree[node].lazy;
    tree[tree[node].right].lazy=tree[node].lazy;
  }
  
  tree[node].lazy=-1;
}

void update(int node, int from, int to, int value) {
  push_lazy(node);

  if(tree[node].from>tree[node].to || from>to || tree[node].from>to || tree[node].to<from) return;

  if(tree[node].from>=from && tree[node].to<=to) {
    tree[node].sum=value*1ll*(tree[node].to-tree[node].from+1);
    tree[node].max=value;

    if(tree[node].from<tree[node].to) {
      extend_left(node);
      extend_right(node);

      tree[tree[node].left].lazy=value;
      tree[tree[node].right].lazy=value;
    }

    return;
  }

  int mid=(from+to)/2;

  if(1) {//if(from<=mid) {
    extend_left(node);
    update(tree[node].left,from,to,value);
  }

  if(1) {//if(to>=mid+1) {
    extend_right(node);
    update(tree[node].right,from,to,value);
  }

  tree[node].sum=get_sum(tree[node].left)+get_sum(tree[node].right);
  tree[node].max=max(get_max(tree[node].left),get_max(tree[node].right));
}

//  { sum, min }
pair < long long, int > query(int node, int from, int to) {
  if(tree[node].from>tree[node].to || from>to || tree[node].from>to || tree[node].to<from) return make_pair(0,-INF);
  
  push_lazy(node);

  if(tree[node].from>=from && tree[node].to<=to) {
    return make_pair(tree[node].sum,tree[node].max);
  }

  pair < long long, int > ans(0,-INF);

  int mid=(tree[node].from+tree[node].to)/2;

  if(1) {//if(from<=mid) {
    extend_left(node);
    ans=merge_pairs(ans,query(tree[node].left,from,to));
  }

  if(1) {//if(to>=mid+1) {
    extend_right(node);
    ans=merge_pairs(ans,query(tree[node].right,from,to));
  }

  return ans;
}

void make_update(int from, int to, int value) {
  int x=-1,y=-1;

  /*for(int i=from;i<=to;i++) {
    if(query(1,i,i).second>value) {
      printf("Value on index %d is %d, chaning it to %d\n", i, query(1,i,i).second,value);
      update(1,i,i,value);
    }
  }

  return;*/

  int left,right,middle;

  left=from-1;
  right=to+1;

  while(right-left>1) {
    middle=(left+right)>>1;

    if(query(1,from,middle).second>value) right=middle;
    else left=middle;
  }

  x=right;

  left=from-1;
  right=to+1;
  while(right-left>1) {
    middle=(left+right)>>1;
    
    if(query(1,middle,to).second>value) left=middle;
    else right=middle;
  }

  y=left;

/*
  for(x=from;x<=to;x++) {
    int curr=query(1,from,x).second;
    if(curr>value) break;
  }

  for(y=to;y>=from;y--) {
    int curr=query(1,y,to).second;
    if(curr>value) break;
  }
*/
  if(x<=y) {
    update(1,x,y,value);
  }
}

long long init(int L, int K, int N, int POS[], int PRICE[]) {
  int i;

  l=L;
  k=K;
  n=N;
  for(i=0;i<n;i++) {
    pos[i]=POS[i];
    price[i]=PRICE[i];
  }

  new_node(1,l);

  for(i=0;i<n;i++) {
    if(pos[i]==l) continue;
    make_update(pos[i]+1,min(l,pos[i]+k),price[i]);
  }

  return query(1,1,l).first;
}

long long addStation(int pos, int price) {
  if(pos<l) make_update(pos+1,min(l,pos+k),price);
  return query(1,1,l).first;
}
