# include <cstdio>
# include <ctime>
# include <vector>
# include <set>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;
const int MAX_X = 4e6 + 10;

vector <int> v[MAX_X];

int n;
int p[MAX_N], w[MAX_N], e[MAX_N];

set <int> x;

int posx[2 * MAX_N], m;

bool cmp (int aa, int bb)
{
	return (v[aa].size () > v[bb].size ());
}

int main ()
{
	int i, j, l, r, ans = 0, cnt = 0, oi, oj;
	
	scanf ("%d", &n);
	for (i = 0; i < n; i ++)
	{
		scanf ("%d%d%d", &p[i], &w[i], &e[i]);
		p[i] += 2000000;
		v[p[i] - w[i]].push_back (i);
		v[p[i] + e[i]].push_back (i);	
		x.insert (p[i] - w[i]);
		x.insert (p[i] + e[i]);
	}
	
	for (set <int> :: iterator it = x.begin (); it != x.end (); it ++)
		posx[m ++] = *it;
		
	sort (posx, posx + m, cmp);
		
	for (i = 0; i < m && (double) clock () < (double) 0.35 * CLOCKS_PER_SEC; i ++)
	{
		int cntc;
		for (cntc = 0, j = m - 1; j > i && cntc < 100; j --, cntc ++)
		{
			oi = i; oj = j;
			i = posx[i];
			j = posx[j];
			l = 0;
			r = 0;
			int crr = 0;
			while (l < v[i].size () && r < v[j].size ())
			{
				crr ++;
				if (v[i][l] < v[j][r])
					l ++;
				else
					if (v[i][l] > v[j][r])
						r ++;
					else
					{
						l ++;
						r ++;
					}
			}
			crr += v[i].size () - l;
			crr += v[j].size () - r;
			
			if (crr > ans)
			{
				ans = crr;
				cnt = 1;
			}
			else
				if (crr == ans)
					cnt ++;
			i = oi;
			j = oj;
		}
		
		int to = j;
		
		for (j = i + 1; j < to && v[posx[i]].size () + v[posx[j]].size () >= ans && (double) clock () < (double) 0.35 * CLOCKS_PER_SEC; j ++)
		{
			oi = i; oj = j;
			i = posx[i];
			j = posx[j];
			l = 0;
			r = 0;
			int crr = 0;
			while (l < v[i].size () && r < v[j].size () && crr + (v[i].size () - l) + (v[j].size () - r) >= ans)
			{
				crr ++;
				if (v[i][l] < v[j][r])
					l ++;
				else
					if (v[i][l] > v[j][r])
						r ++;
					else
					{
						l ++;
						r ++;
					}
			}
			
			if (l == v[i].size () || r == v[j].size ())
			{
			
			crr += v[i].size () - l;
			crr += v[j].size () - r;
			
			if (crr > ans)
			{
				ans = crr;
				cnt = 1;
			}
			else
				if (crr == ans)
					cnt ++;
			}
			i = oi;
			j = oj;
		}
	}

	printf ("%d %d\n", ans, cnt);

	return 0;	
}


