#include<iostream>
#include<stdio.h>
#include<algorithm>
#include<map>
#include<vector>
using namespace std ;

#define MAXN 100007

int n ;
pair < int , int > a[ MAXN ] ;


map < int , int > ZX ;
int MXVAL ;


vector < int > vec_st[ 2 * MAXN ] ;
vector < int > vec_en[ 2 * MAXN ] ;

class Tree {
	public :
	int tr[ 8 * MAXN ] ;
	int tm[ 8 * MAXN ] ;
	void init ( int where , int IL , int IR ) {
		tr[ where ] =  0 ;
		tm[ where ] = 1 ;
		if ( IL == IR ) { return ; }
		int mid = ( IL + IR ) / 2 ;
		init ( 2 * where , IL , mid ) ;
		init ( 2 * where + 1 , mid + 1 , IR ) ;
	}
	void combine ( int where ) {
		if ( tr[ 2 * where ] > tr[ 2 * where + 1 ] ) {
			tr[ where ] = tr[ 2 * where ] ;
			tm[ where ] = tm[ 2 * where ] ;	
		}
		else if ( tr[ 2 * where + 1 ] > tr[ 2 * where ] ) {
			tr[ where ] = tr[ 2 * where + 1 ] ;
			tm[ where ] = tm[ 2 * where + 1 ] ;
		}
		else {
			tr[ where ] = tr[ 2 * where ] ;
			tm[ where ] = ( tm[ 2 * where ] + tm[ 2 * where + 1 ] ) ;
		}
	}
	void update ( int where , int IL , int IR , int pos , int val ) {
		if ( IR < pos || pos < IL ) { return ; }
		if ( IL == IR ) {
			tr[ where ] += val ;
			return ;
		}
		int mid = ( IL + IR ) / 2 ;
		if ( pos <= mid ) { 
			update ( 2 * where , IL , mid , pos , val ) ;
		}
		else { 
			update ( 2 * where + 1 , mid + 1 , IR , pos , val ) ;
		}
		combine ( where ) ;
	}
	pair < int , int > query ( int where , int IL , int IR , int CURL , int CURR ) {
		if ( CURL > CURR ) { return make_pair ( 0 , 0 ) ; }
		if ( IR < CURL || CURR < IL ) { return make_pair ( 0 , 0 ) ; }
		if ( CURL <= IL && IR <= CURR ) {
			return make_pair ( tr[ where ] , tm[ where ] ) ;
		}
		int mid = ( IL + IR ) / 2 ;
		pair < int , int > ret1 = query ( 2 * where , IL , mid , CURL , CURR ) ;
		pair < int , int > ret2 = query ( 2 * where + 1 , mid + 1 , IR , CURL , CURR ) ;
		pair < int , int > aux ;
		if ( ret1.first > ret2.first ) { aux = ret1 ; }
		else if ( ret1.first < ret2.first ) { aux = ret2 ; }
		else { aux.first = ret1.first ; aux.second = ( ret1.second + ret2.second ) ; }
		return aux ;
	}
};

Tree w ;


void compress ( ) {
	vector < int > srt ;
	int i ;
	for ( i = 1 ; i <= n ; i ++ ) {
		srt.push_back ( a[ i ].first ) ;	
		srt.push_back ( a[ i ].second ) ;
	}
	sort ( srt.begin ( ) , srt.end ( ) ) ;
	int id = 1 ;
	ZX[ srt[ 0 ] ] = 1 ;
	for ( i = 1 ; i < 2 * n ; i ++ ) {
		if ( srt[ i ] == srt[ i - 1 ] ) { continue ; }
		id ++ ;
		ZX[ srt[ i ] ] = id ;
	}
	for ( i = 1 ; i <= n ; i ++ ) {
		a[ i ].first = ZX[ a[ i ].first ] ;
		a[ i ].second = ZX[ a[ i ].second ] ;
		vec_st[ a[ i ].first ].push_back ( i ) ;
		vec_en[ a[ i ].second ].push_back ( i ) ;
	}
	MXVAL = id ;
	/**
	for ( i = 1 ; i <= n ; i ++ ) {
		printf ( "%d --> %d\n" , a[ i ].second , ZX[ a[ i ].second ] ) ;
	}
	**/
}

void input ( ) {
	scanf ( "%d" , &n ) ;
	int i ;
	for ( i = 1 ; i <= n ; i ++ ) {
		int x , y , z ;
		scanf ( "%d%d%d" , &x , &y , &z ) ;
		a[ i ].first = x - y ;
		a[ i ].second = x + z ;
	}
	sort ( a + 1 , a + n + 1 ) ;
	compress ( ) ;
	/**
	for ( i = 1 ; i <= n ; i ++ ) {
		printf ( "%d %d\n" , a[ i ].first , a[ i ].second ) ;
	}	
	**/
}


void solve ( ) {
	w.init ( 1 , 1 , MXVAL ) ;
	int i , j ;
	for ( i = 1 ; i <= n ; i ++ ) {
		w.update ( 1 , 1 , MXVAL , a[ i ].first , 1 ) ; 	
		w.update ( 1 , 1 , MXVAL , a[ i ].second , 1 ) ; 
	}
	long long ans1 , ans2 ;
	ans1 = ans2 = 0 ;
	for ( i = 1 ; i <= MXVAL ; i ++ ) {
		int sz1 = vec_st[ i ].size ( ) ;
		int sz2 = vec_en[ i ].size ( ) ;
		int cur = sz1 + sz2 ;
		long long tm = 1 ;
		for ( j = 0 ; j < sz1 ; j ++ ) {
			w.update ( 1 , 1 , MXVAL , a[ vec_st[ i ][ j ] ].second , -1 ) ;
		}
		for ( j = 0 ; j < sz2 ; j ++ ) {
			w.update ( 1 , 1 , MXVAL , a[ vec_en[ i ][ j ] ].first , -1 ) ;
		}
		
		pair < int , int > ret = w.query ( 1 , 1 , MXVAL , i + 1 , MXVAL ) ;
		if ( ans1 < cur + ret.first ) {
			ans1 = cur + ret.first ;
			ans2 = 0 ;
		}
		
		if ( ans1 == cur + ret.first ) {
			ans2 += ret.second ;
		}		
		for ( j = 0 ; j < sz1 ; j ++ ) {
			w.update ( 1 , 1 , MXVAL , a[ vec_st[ i ][ j ] ].second , 1 ) ;
		}
		for ( j = 0 ; j < sz2 ; j ++ ) {
			w.update ( 1 , 1 , MXVAL , a[ vec_en[ i ][ j ] ].first , 1 ) ;
		}		
	}
	cout << ans1 << " " << ans2 << "\n" ;
}

int main ( ) { 
	input ( ) ;
	solve ( ) ;
	return 0 ;
}
