#include <bits/stdc++.h>
#include "stations.h"
#define Init init
#define AddStation addStation
using namespace std;

int32_t n, l, k;
set< pair< int32_t, int32_t > > sortedStations;

int64_t Solve() {
	vector< pair< int32_t, int32_t > > stations;
	for(auto &s : sortedStations) {
		stations.push_back(s);
	}

	bool isChanged = false;
	if(stations.back().first != l) {
		stations.push_back({ l, 0 });
		n++;
		isChanged = true;
	}

	vector< int32_t > firstLessToRight(n);
	stack< pair< int32_t, int32_t > > st;
	for(int32_t i = n - 1; i >= 0; i--) {
		while(!st.empty() && st.top().second >= stations[i].second) {
			st.pop();
		}

		if(st.empty()) {
			firstLessToRight[i] = -1;
		}
		else {
			firstLessToRight[i] = st.top().first;
		}

		st.push({ i, stations[i].second });
	}

	int32_t currStation = 0, currFuel = 0;
	int64_t ans = 0;

	while(currStation != n - 1) {
		int32_t smallerToRight = firstLessToRight[currStation];

		if(smallerToRight == -1 || stations[currStation].first + k < stations[smallerToRight].first) {
			ans += 1ll * (k - currFuel) * stations[currStation].second;
			
			currFuel = k - (stations[currStation + 1].first - stations[currStation].first);
			currStation++;
		}
		else if(stations[currStation].first + currFuel >= stations[smallerToRight].first) {
			currFuel -= stations[smallerToRight].first - stations[currStation].first;
			currStation = smallerToRight;
		}
		else {
			ans += 1ll * (stations[smallerToRight].first - stations[currStation].first - currFuel) * stations[currStation].second;

			currFuel = 0;
			currStation = smallerToRight;
		}
	}

	if(isChanged) {
		n--;
	}

	return ans;
}

int64_t Init(int32_t L, int32_t K, int32_t N, int32_t stationPositions[], int32_t stationOilPrices[]) {
	for(int32_t i = 0; i < N; i++) {
		sortedStations.insert({ stationPositions[i], stationOilPrices[i] });
	}

	l = L;
	k = K;
	n = N;
	return Solve();
}

int64_t AddStation(int32_t newStationPosition, int32_t newStationOilPrice) {
	sortedStations.insert({ newStationPosition, newStationOilPrice });
	
	n++;
	return Solve();
}

/**
int main() {
	int32_t n = 5, l = 100, k = 42;
	int32_t stationPositions[10] = { 82, 0, 35, 68, 40 };
	int32_t stationOilPrices[10] = { 216, 210, 215, 220, 212 };

	cout << Init(l, k, n, stationPositions, stationOilPrices) << endl;
	cout << AddStation(90, 209) << endl;
}
*/
