#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 100;

char board[MAX_N + 5][MAX_N + 5];

void Solve1(int32_t n, string &ans) {
	for(int32_t i = 0; i < n; i++) {
		if(i % 2 == 0) {
			for(int32_t j = 0; j < n - 1; j++) {
				ans += 'R';
			}

			if(i != n - 1) {
				ans += 'D';
			}
		}
		else {
			for(int32_t j = 0; j < n - 1; j++) {
				ans += 'L';
			}

			if(i != n - 1) {
				ans += 'D';
			}
		}
	}
}

void Solve2(int32_t n, string &ans) {
	vector< int32_t > heights = { 7, 11, 5, 9, 12, 2, 5, 13, 2, 10, 13, 5, 11, 4, 11 };

	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = 0; j < heights[i] - 1; j++) {
			ans += 'D';
		}
		for(int32_t j = 0; j < heights[i] - 1; j++) {
			ans += 'U';
		}

		if(i != n - 1) {
			ans += 'R';
		}
	}
}

void Solve3(int32_t n, string &ans) {
	queue< pair< int32_t, int32_t > > q;
	q.push({ 0, 0 });

	map< pair< int32_t, int32_t >, bool > isVisited;
	isVisited[q.front()] = true;

	const int32_t ROWS_DELTA[] = { -1, 0, 1, 0 };
	const int32_t COLS_DELTA[] = { 0, 1, 0, -1 };
	const char ENC[] = { 'U', 'R', 'D', 'L' };

	while(!q.empty()) {
		pair< int32_t, int32_t > curr = q.front();
		q.pop();

		for(int32_t i = 0; i < 4; i++) {
			pair< int32_t, int32_t > nxt = { curr.first + ROWS_DELTA[i], curr.second + COLS_DELTA[i] };

			if(nxt.first < 0 || nxt.first >= n || nxt.second < 0 || nxt.second >= n) {
				continue;
			}

			if(!isVisited[nxt] && board[nxt.first][nxt.second] == 'B') {
				q.push(nxt);
				isVisited[nxt] = true;

				ans += ENC[i];
			}
		}
	}
}

void Solve4(int32_t n, string &ans) {
	ans = "RRRRDLLLLDRRRRDDDULULLLDDDDDrULUUDDdDRRRUDLDLLDRLDDRDLRRRRRRuLDLULLDURRRRdRUUUU";	
	ans += "DDDDRUDRRRRRRULLLRURRULLULRRRULUR";
	ans += "ULULRRULLLLLDDRLUUURRRRR";
	ans += "ULLLLURRRRLLLLLLLD";
	ans += "LDUuDrUULRRRRRRRRULLLLLLL";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t n;
	cin >> n;

	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = 0; j < n; j++) {
			cin >> board[i][j];
		}
	}

	int32_t testInd;
	cin >> testInd;
	
	string ans = "";
	if(testInd == 1) {
		Solve1(n, ans);
	}
	else if(testInd == 2) {
		Solve2(n, ans);
	}
	else if(testInd == 3) {
		Solve3(n, ans);
	}
	else if(testInd == 4) {
		Solve4(n, ans);
	}

	cout << ans << endl;
}
