#include <bits/stdc++.h>
#include "stations.h"
#define Init init
#define AddStation addStation
using namespace std;

int n, l, k, oldAns;
set< pair< int, int > > sortedStations;

long long Solve() {
	vector< pair< int, int > > stations;
	for(auto &s : sortedStations) {
		stations.push_back(s);
	}

	bool isChanged = false;
	if(stations.back().first != l) {
		stations.push_back({ l, 0 });
		n++;
		isChanged = true;
	}

	vector< int > firstLessToRight(n);
	stack< pair< int, int > > st;
	for(int i = n - 1; i >= 0; i--) {
		while(!st.empty() && st.top().second >= stations[i].second) {
			st.pop();
		}

		if(st.empty()) {
			firstLessToRight[i] = -1;
		}
		else {
			firstLessToRight[i] = st.top().first;
		}

		st.push({ i, stations[i].second });
	}

	int currStation = 0, currFuel = 0;
	long long ans = 0;

	while(currStation != n - 1) {
		int smallerToRight = firstLessToRight[currStation];

		if(smallerToRight == -1 || stations[currStation].first + k < stations[smallerToRight].first) {
			ans += 1ll * (k - currFuel) * stations[currStation].second;
			
			currFuel = k - (stations[currStation + 1].first - stations[currStation].first);
			currStation++;
		}
		else if(stations[currStation].first + currFuel >= stations[smallerToRight].first) {
			currFuel -= stations[smallerToRight].first - stations[currStation].first;
			currStation = smallerToRight;
		}
		else {
			ans += 1ll * (stations[smallerToRight].first - stations[currStation].first - currFuel) * stations[currStation].second;

			currFuel = 0;
			currStation = smallerToRight;
		}
	}

	if(isChanged) {
		n--;
	}

	return ans;
}

long long Init(int L, int K, int N, int stationPositions[], int stationOilPrices[]) {
	for(int i = 0; i < N; i++) {
		sortedStations.insert({ stationPositions[i], stationOilPrices[i] });
	}

	l = L;
	k = K;
	n = N;
	
	oldAns = Solve();
	return oldAns;
}

long long AddStation(int newStationPosition, int newStationOilPrice) {
	if(newStationPosition == l) {
		return oldAns;
	}

	sortedStations.insert({ newStationPosition, newStationOilPrice });

	n++;
	long long newAns = Solve();
	oldAns = newAns;
	
	return newAns;
}

/**
int main() {
	int n = 5, l = 100, k = 42;
	int stationPositions[10] = { 82, 0, 35, 68, 40 };
	int stationOilPrices[10] = { 216, 210, 215, 220, 212 };

	cout << Init(l, k, n, stationPositions, stationOilPrices) << endl;
	cout << AddStation(90, 209) << endl;
}
*/
