#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 1e5;

map< pair< int32_t, int32_t >, int32_t > cntPairs;
map< pair< int32_t, int32_t >, bool > haveCounted;
map< int32_t, int32_t > cntSingles;

pair< int32_t, int32_t > pairs[MAX_N + 5];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t n;
	cin >> n;

	set< int32_t > allPoints; 
	for(int32_t i = 0; i < n; i++) {
		int32_t p, e, w;
		cin >> p >> w >> e;

		pairs[i] = { p - w, p + e };

		cntSingles[p - w]++;
		cntSingles[p + e]++;
		cntPairs[pairs[i]]++;

		allPoints.insert(p - w);
		allPoints.insert(p + e);
	}
	
	if(n <= 5000) {
		vector< int32_t > v;
		for(auto &x : allPoints) {
			v.push_back(x);
		}

		int32_t maxCnt = 0, cntWithMaxCnt = 0;
		for(int32_t i = 0; i < (int32_t) v.size(); i++) {
			for(int32_t j = i + 1; j < (int32_t) v.size(); j++) {
				pair< int32_t, int32_t > p = { v[i], v[j] };

				int32_t currCnt = cntSingles[v[i]] + cntSingles[v[j]] - cntPairs[p];

				if(currCnt > maxCnt) {
					maxCnt = currCnt;
					cntWithMaxCnt = 1;
				}
				else if(currCnt == maxCnt) {
					cntWithMaxCnt++;
				}
			}
		}

		cout << maxCnt << " " << cntWithMaxCnt << endl;
	}	
	else {
		vector< pair< int32_t, int32_t > > v;
		for(auto &p : allPoints) {
			v.push_back({ cntSingles[p], p });
		}

		sort(v.begin(), v.end());

		int32_t maxAns = 0, ansCnt = 0;
		
		for(int32_t i = 0; i < n; i++) {
			if(haveCounted[pairs[i]]) {
				continue;
			}

			int32_t curr = cntSingles[pairs[i].first] + cntSingles[pairs[i].second] - cntPairs[pairs[i]];

			if(curr > maxAns) {
				maxAns = curr;
				ansCnt = 1;
			}
			else if(curr == maxAns) {
				ansCnt++;
			}
		}
		
		for(int32_t i = 0; i < min(2 * n, 500); i++) {
			for(int32_t j = i + 1; j < min(2 * n, 500); j++) {
				pair< int32_t, int32_t > p = { min(v[i].second, v[j].second), max(v[i].second, v[j].second) };
				int32_t currAns = v[i].first + v[j].first - cntPairs[p];

				if(currAns > maxAns) {
					maxAns = currAns;
					ansCnt = 1;
				}
				else if(currAns == maxAns) {
					ansCnt++;
				}
			}
		}

		cout << maxAns << " " << ansCnt << endl;
	}
}
