#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 1e5 + 5;
const int INF = 1e7;

int n;
struct road_sign{

   int P;
   int E, W;

   bool operator < (const road_sign &other)
   {
       return P < other.P;
   }

}a[N];

pair <ll, ll> solve2(int L, int R)
{
    set < pair <int, int> > s;
    int pL, pR;

    pL = a[L].P - a[L].W;
    pR = a[R].P - a[R].W;
    if(pL != pR)
    {
        if(pL > pR)
            swap(pL, pR);
        s.insert(mp(pL, pR));
    }

    pL = a[L].P + a[L].E;
    pR = a[R].P - a[R].W;
    if(pL != pR)
    {
        if(pL > pR)
            swap(pL, pR);
        s.insert(mp(pL, pR));
    }

    pL = a[L].P - a[L].W;
    pR = a[R].P + a[R].E;
    if(pL != pR)
    {
        if(pL > pR)
            swap(pL, pR);
        s.insert(mp(pL, pR));
    }

    pL = a[L].P + a[L].E;
    pR = a[R].P + a[R].E;
    if(pL != pR)
    {
        if(pL > pR)
            swap(pL, pR);
        s.insert(mp(pL, pR));
    }

    return mp(2, (long long)s.size());
}

bool can(road_sign _t, int _X)
{
    if(_t.P - _t.W == _X || _t.P + _t.E == _X)
        return true;
    return false;
}

long long check(int L, int R, int X, int Y)
{
    int res = 0;
    for(int i = L; i <= R; i++)
    {
        if(can(a[i], X) || can(a[i], Y))
            res++;
    }

    return res;
}

pair <ll, ll> conquer(int L, int R) /// (vajnost, broika)
{
   if(L == R)
       return mp(1, 1);

   if(L + 1 == R)
       return solve2(L, R);

   int mid = (L + R) / 2;

   pair <ll, ll> resLeft, resRight;
   resLeft = conquer(L, mid - 1);
   resRight = conquer(mid + 1, R);

   pair <ll, ll> resWithMid;
   int X, Y, res;

   resWithMid = mp(0, 0);


   X = a[mid].P - a[mid].W;
   Y = -INF;
   for(int i = mid + 1; i <= R; i++)
   {
       if(!can(a[i], X))
       {
            Y = a[i].P - a[i].W;
            if(Y != a[mid].P + a[mid].E)
            {
               res = check(L, R, X, Y);
               if(res > resWithMid.first)
               {
                   resWithMid.second = 0;
                   resWithMid.first = res;
               }
               if(res == resWithMid.first)
               {
                   resWithMid.second++;
               }
            }

            Y = a[i].P + a[i].E;
            if(Y != a[mid].P + a[mid].E)
            {
               res = check(L, R, X, Y);
               if(res > resWithMid.first)
               {
                   resWithMid.second = 0;
                   resWithMid.first = res;
               }
               if(res == resWithMid.first)
               {
                   resWithMid.second++;
               }
            }
       }
   }

   X = a[mid].P - a[mid].W;
   Y = -INF;
   for(int i = mid - 1; i >= L; i--)
   {
       if(!can(a[i], X))
       {
            Y = a[i].P - a[i].W;
            if(Y != a[mid].P + a[mid].E)
            {
               res = check(L, R, X, Y);
               if(res > resWithMid.first)
               {
                   resWithMid.second = 0;
                   resWithMid.first = res;
               }
               if(res == resWithMid.first)
               {
                   resWithMid.second++;
               }
            }

            Y = a[i].P + a[i].E;
            if(Y != a[mid].P + a[mid].E)
            {
               res = check(L, R, X, Y);
               if(res > resWithMid.first)
               {
                   resWithMid.second = 0;
                   resWithMid.first = res;
               }
               if(res == resWithMid.first)
               {
                   resWithMid.second++;
               }
            }
       }
   }



   X = a[mid].P + a[mid].E;
   Y = -INF;
   for(int i = mid + 1; i <= R; i++)
   {
       if(!can(a[i], X))
       {
               Y = a[i].P - a[i].W;
               res = check(L, R, X, Y);
               if(res > resWithMid.first)
               {
                   resWithMid.second = 0;
                   resWithMid.first = res;
               }
               if(res == resWithMid.first)
               {
                   resWithMid.second++;
               }

               Y = a[i].P + a[i].E;

               res = check(L, R, X, Y);
               if(res > resWithMid.first)
               {
                   resWithMid.second = 0;
                   resWithMid.first = res;
               }
               if(res == resWithMid.first)
               {
                   resWithMid.second++;
               }
       }
   }

   X = a[mid].P + a[mid].E;
   Y = -INF;
   for(int i = mid - 1; i >= L; i--)
   {
       if(!can(a[i], X))
       {
               Y = a[i].P - a[i].W;
               res = check(L, R, X, Y);
               if(res > resWithMid.first)
               {
                   resWithMid.second = 0;
                   resWithMid.first = res;
               }
               if(res == resWithMid.first)
               {
                   resWithMid.second++;
               }

               Y = a[i].P + a[i].E;
               res = check(L, R, X, Y);
               if(res > resWithMid.first)
               {
                   resWithMid.second = 0;
                   resWithMid.first = res;
               }
               if(res == resWithMid.first)
               {
                   resWithMid.second++;
               }
       }
   }

   long long best = 0, times = 0;
   best = max(resLeft.first, resRight.first);
   best = max(best, resWithMid.first);

   if(resLeft.first == best)
     times += resLeft.second;
   if(resRight.first == best)
     times += resRight.second;
   if(resWithMid.first == best)
     times += resWithMid.second;

   return best;
}


pair <ll, ll> ans;

int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr); cout.tie(nullptr);

   int i;

   cin >> n;
   for(i = 1; i <= n; i++)
       cin >> a[i].P >> a[i].W >> a[i].E;

   sort(a + 1, a + n + 1);

   ans = conquer(1, n);
   cout << ans.first << " " << ans.second << endl;

   return 0;
}


/*

11
17 10 19
-8 2 50
-2 11 3
0 13 42
3 2 6
7 33 15
11 10 31
12 25 4
13 10 7
14 10 10
17 16 25

*/
