#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 1e5 + 5;
const int INF = 1e7;

int n;
struct road_sign{

   int P;
   int E, W;

   bool operator < (const road_sign &other)
   {
       return P < other.P;
   }

}a[N];

map <int, set < pair <int, int> > > ans_count;

long long solve2(int L, int R)
{
    int pL, pR;

    pL = a[L].P - a[L].W;
    pR = a[R].P - a[R].W;
    if(pL != pR)
    {
        if(pL > pR)
            swap(pL, pR);
        ans_count[2].insert(mp(pL, pR));
    }

    pL = a[L].P + a[L].E;
    pR = a[R].P - a[R].W;
    if(pL != pR)
    {
        if(pL > pR)
            swap(pL, pR);
        ans_count[2].insert(mp(pL, pR));
    }

    pL = a[L].P - a[L].W;
    pR = a[R].P + a[R].E;
    if(pL != pR)
    {
        if(pL > pR)
            swap(pL, pR);
        ans_count[2].insert(mp(pL, pR));
    }

    pL = a[L].P + a[L].E;
    pR = a[R].P + a[R].E;
    if(pL != pR)
    {
        if(pL > pR)
            swap(pL, pR);
        ans_count[2].insert(mp(pL, pR));
    }

    return 2;
}

bool can(road_sign _t, int _X)
{
    if(_t.P - _t.W == _X || _t.P + _t.E == _X)
        return true;
    return false;
}

int check(int L, int R, int X, int Y)
{
    int res = 0;
    for(int i = L; i <= R; i++)
    {
        if(can(a[i], X) || can(a[i], Y))
            res++;
    }

    return res;
}

int conquer(int L, int R) /// (vajnost, broika)
{
   if(L == R)
       return 1;

   if(L + 1 == R)
       return 2;

   int mid = (L + R) / 2;

   int resLeft, resRight;
   resLeft = conquer(L, mid - 1);
   resRight = conquer(mid + 1, R);

   int resWithMid = 0;
   int X, Y, res;

   X = a[mid].P - a[mid].W;
   Y = -INF;
   for(int i = mid + 1; i <= R; i++)
   {
       if(!can(a[i], X))
       {
               Y = a[i].P - a[i].W;

               res = check(L, R, X, Y);
               if(res > resWithMid)
               {
                   resWithMid = res;
               }

               Y = a[i].P + a[i].E;

               res = check(L, R, X, Y);
               if(res > resWithMid)
               {
                   resWithMid = res;
               }
       }
   }

   X = a[mid].P - a[mid].W;
   Y = -INF;
   for(int i = mid - 1; i >= L; i--)
   {
       if(!can(a[i], X))
       {
               Y = a[i].P - a[i].W;

               res = check(L, R, X, Y);
               if(res > resWithMid)
               {
                   resWithMid = res;
               }

               Y = a[i].P + a[i].E;

               res = check(L, R, X, Y);
               if(res > resWithMid)
               {
                   resWithMid = res;
               }
       }
   }

   /// DONE WITH FIRST CASE

   X = a[mid].P + a[mid].E;
   Y = -INF;
   for(int i = mid + 1; i <= R; i++)
   {
       if(!can(a[i], X))
       {
               Y = a[i].P - a[i].W;

               res = check(L, R, X, Y);
               if(res > resWithMid)
               {
                   resWithMid = res;
               }

               Y = a[i].P + a[i].E;

               res = check(L, R, X, Y);
               if(res > resWithMid)
               {
                   resWithMid = res;
               }
       }
   }

   X = a[mid].P + a[mid].E;
   Y = -INF;
   for(int i = mid - 1; i >= L; i--)
   {
       if(!can(a[i], X))
       {
               Y = a[i].P - a[i].W;

               res = check(L, R, X, Y);
               if(res > resWithMid)
               {
                   resWithMid = res;
               }

               Y = a[i].P + a[i].E;

               res = check(L, R, X, Y);
               if(res > resWithMid)
               {
                   resWithMid = res;
               }
       }
   }

   /// DONE WITH SECOND CASE

   int best = 0;
   best = max(resLeft, resRight);
   best = max(best, resWithMid);

   return best;
}


int ans;

int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr); cout.tie(nullptr);

   int i;

   cin >> n;
   for(i = 1; i <= n; i++)
       cin >> a[i].P >> a[i].W >> a[i].E;

   sort(a + 1, a + n + 1);

   ans = conquer(1, n);
   cout << ans << " " << 1 << endl;


   return 0;
}


/*

11
17 10 19
-8 2 50
-2 11 3
0 13 42
3 2 6
7 33 15
11 10 31
12 25 4
13 10 7
14 10 10
17 16 25

*/


/*

24
-10 9 1
-9 20 10
-8 1 11
-7 12 17
-6 20 16
-5 22 13
-4 30 6
-3 20 7
-2 25 16
-1 3 21
0 30 7
1 17 22
2 9 5
3 25 18
4 21 13
5 16 17
6 4 5
7 15 8
8 11 24
9 26 3
10 25 14
11 2 21
12 22 5
13 24 17

*/
