#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <ctime>
#include <cstdlib>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 1e5 + 5;
const int INF = 4e6;
const double TL = 0.37;

int n;
struct road_sign{

   int P;
   int E, W;

   bool operator < (const road_sign &other)
   {
       return P < other.P;
   }

}a[N];


int ans;

map < pair <int, int>, vector <int> > dic;
map <int, vector <int> > dic_solo;
int get_cnt(int L, int R, int X, int Y)
{
    if(dic.find(mp(X, Y)) == dic.end())
        return 0;

    int low, high, mid;
    int lb = -1, ub = -1;

    low = 0;
    high = (int)dic[mp(X, Y)].size() - 1;
    while(low <= high)
    {
        mid = (low + high) / 2;
        if(dic[mp(X, Y)][mid] >= L)
        {
            lb = mid;
            high = mid - 1;
        }
        else
        {
            low = mid + 1;
        }
    }

    low = 0;
    high = (int)dic[mp(X, Y)].size() - 1;
    while(low <= high)
    {
        mid = (low + high) / 2;
        if(dic[mp(X, Y)][mid] <= R)
        {
            ub = mid;
            low = mid + 1;
        }
        else
        {
            high = mid - 1;
        }
    }

    if(lb == -1 || ub == -1)
        return 0;
    return ub - lb + 1;
}

int solo_cnt(int L, int R, int X)
{
    if(dic_solo.find(X) == dic_solo.end())
        return 0;

    int low, high, mid;
    int lb = -1, ub = -1;

    low = 0;
    high = (int)dic_solo[X].size() - 1;
    while(low <= high)
    {
        mid = (low + high) / 2;
        if(dic_solo[X][mid] >= L)
        {
            lb = mid;
            high = mid - 1;
        }
        else
        {
            low = mid + 1;
        }
    }

    low = 0;
    high = (int)dic_solo[X].size() - 1;
    while(low <= high)
    {
        mid = (low + high) / 2;
        if(dic_solo[X][mid] <= R)
        {
            ub = mid;
            low = mid + 1;
        }
        else
        {
            high = mid - 1;
        }
    }

    if(lb == -1 || ub == -1)
        return 0;
    return ub - lb + 1;
}

int cnt[2 * INF];
int cnt_points;



bool can(road_sign _t, int _X)
{
    if(_t.P - _t.W == _X || _t.P + _t.E == _X)
        return true;
    return false;
}

int check(int L, int R, int X, int Y)
{
    if(X > Y)
        swap(X, Y);

    int res;
    res = solo_cnt(L, R, X) + solo_cnt(L, R, Y) - get_cnt(L, R, X, Y);

    return res;
}

int conquer(int L, int R) /// (vajnost, broika)
{
   if(L == R)
       return 1;

   if(L + 1 == R)
       return 2;

   int mid = (L + R) / 2;

   int resLeft, resRight;
   resLeft = conquer(L, mid - 1);
   resRight = conquer(mid + 1, R);

   int resWithMid = 0;
   int X, Y, res;

   X = a[mid].P - a[mid].W;
   for(int i = mid + 1; i <= R; i++)
   {
       if(!can(a[i], X))
       {
               Y = a[i].P - a[i].W;
               resWithMid = max(resWithMid, check(L, R, X, Y));

               Y = a[i].P + a[i].E;
               resWithMid = max(resWithMid, check(L, R, X, Y));
       }
   }

   X = a[mid].P - a[mid].W;
   for(int i = mid - 1; i >= L; i--)
   {
       if(!can(a[i], X))
       {
               Y = a[i].P - a[i].W;
               resWithMid = max(resWithMid, check(L, R, X, Y));

               Y = a[i].P + a[i].E;
               resWithMid = max(resWithMid, check(L, R, X, Y));
       }
   }

   /// DONE WITH FIRST CASE

   X = a[mid].P + a[mid].E;
   for(int i = mid + 1; i <= R; i++)
   {
       if(!can(a[i], X))
       {
               Y = a[i].P - a[i].W;
               resWithMid = max(resWithMid, check(L, R, X, Y));

               Y = a[i].P + a[i].E;
               resWithMid = max(resWithMid, check(L, R, X, Y));
       }
   }

   X = a[mid].P + a[mid].E;
   for(int i = mid - 1; i >= L; i--)
   {
       if(!can(a[i], X))
       {
               Y = a[i].P - a[i].W;
               resWithMid = max(resWithMid, check(L, R, X, Y));

               Y = a[i].P + a[i].E;
               resWithMid = max(resWithMid, check(L, R, X, Y));
       }
   }


   /// DONE WITH SECOND CASE

   int best = 0;
   best = max(resLeft, resRight);
   best = max(best, resWithMid);

   return best;
}

vector <int> potential, new_potential;

int main()
{
   ios_base::sync_with_stdio(false);
   cin.tie(nullptr); cout.tie(nullptr);
   srand(2233557);

   int i;

   cin >> n;
   for(i = 1; i <= n; i++)
   {
       cin >> a[i].P >> a[i].W >> a[i].E;
       a[i].P += INF;
   }

   ans = conquer(1, n);

   for(i = 1; i <= n; i++)
   {
        dic[mp(a[i].P - a[i].W, a[i].P + a[i].E)].pb(i);
        dic_solo[a[i].P - a[i].W].pb(i);
        dic_solo[a[i].P + a[i].E].pb(i);
   }

   for(i = 1; i <= n; i++)
   {
       potential.pb(a[i].P - a[i].W);
       potential.pb(a[i].P + a[i].E);

       cnt[a[i].P - a[i].W]++;
       cnt[a[i].P + a[i].E]++;
   }

   sort(potential.begin(), potential.end());
   for(i = 0; i < potential.size();)
   {
        int j = i + 1;
        while(j < potential.size() && potential[j] == potential[i])
        {
            j++;
        }

        new_potential.pb(potential[i]);
        i = j;
   }
   potential = new_potential;

   random_shuffle(potential.begin(), potential.end());

   for(i = 0; i < potential.size(); i++)
   {
      for(int j = i + 1; j < potential.size(); j++)
      {
          if(clock() > (double)CLOCKS_PER_SEC * TL)
          {
              cout << ans << " " << cnt_points << endl;
              return 0;
          }

          if(check(1, n, potential[i], potential[j]) > ans)
          {
             ans = check(1, n, potential[i], potential[j]);
             cnt_points = 0;
          }
          if(check(1, n, potential[i], potential[j]) == ans)
          {
              cnt_points++;
          }
      }
   }



   cout << ans << " " << cnt_points << endl;



   return 0;
}


/*

11
17 10 19
-8 2 50
-2 11 3
0 13 42
3 2 6
7 33 15
11 10 31
12 25 4
13 10 7
14 10 10
17 16 25

*/


/*

24
-10 9 1
-9 20 10
-8 1 11
-7 12 17
-6 20 16
-5 22 13
-4 30 6
-3 20 7
-2 25 16
-1 3 21
0 30 7
1 17 22
2 9 5
3 25 18
4 21 13
5 16 17
6 4 5
7 15 8
8 11 24
9 26 3
10 25 14
11 2 21
12 22 5
13 24 17

*/
